(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     11065,        258]
NotebookOptionsPosition[     10631,        237]
NotebookOutlinePosition[     10970,        252]
CellTagsIndexPosition[     10927,        249]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"LoadNETAssembly", "[", 
  RowBox[{"\"\<Tinkerforge\>\"", ",", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.600175052949191*^9, 3.600175066601799*^9}, 
   3.600175102142559*^9, {3.6001753172765293`*^9, 3.600175317946432*^9}, {
   3.600500538026902*^9, 3.600500561851948*^9}, {3.600506097634747*^9, 
   3.600506099012146*^9}, 3.600506136278721*^9, {3.60060805238198*^9, 
   3.600608117803465*^9}, 3.600685373189396*^9}],

Cell[BoxData[{
 RowBox[{"host", "=", "\"\<localhost\>\""}], "\n", 
 RowBox[{"port", "=", "4223"}], "\n", 
 RowBox[{
  RowBox[{"uid", "=", "\"\<XYZ\>\""}], 
  RowBox[{"(*", 
   RowBox[{"Change", " ", "to", " ", "your", " ", "UID"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"width", "=", "128"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"height", "=", "64"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DrawMatrix", "[", 
    RowBox[{"oled_", ",", "pixels_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pages", ",", "row", ",", "column", ",", "bit", ",", "page"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"pages", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "0", ",", 
           RowBox[{
            RowBox[{"height", "/", "8"}], "-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "0", ",", 
           RowBox[{"width", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"row", "=", "0"}], ",", 
        RowBox[{"row", "<", 
         RowBox[{"Floor", "[", 
          RowBox[{"height", "/", "8"}], "]"}]}], ",", 
        RowBox[{"row", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"column", "=", "0"}], ",", 
          RowBox[{"column", "<", "width"}], ",", 
          RowBox[{"column", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"page", "=", "0"}], ";", "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"bit", "=", "0"}], ",", 
             RowBox[{"bit", "<", "8"}], ",", 
             RowBox[{"bit", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"pixels", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"row", "*", "8"}], "+", "bit", "+", "1"}], "]"}], 
                 "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"column", "+", "1"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"page", "=", 
                RowBox[{"BitOr", "[", 
                 RowBox[{"page", ",", 
                  RowBox[{"BitShiftLeft", "[", 
                   RowBox[{"1", ",", "bit"}], "]"}]}], "]"}]}]}], 
              "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"pages", "[", 
              RowBox[{"[", 
               RowBox[{"row", "+", "1"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"column", "+", "1"}], "]"}], "]"}], "=", "page"}]}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"oled", "@", 
       RowBox[{"NewWindow", "[", 
        RowBox[{"0", ",", 
         RowBox[{"width", "-", "1"}], ",", "0", ",", 
         RowBox[{
          RowBox[{"Floor", "[", 
           RowBox[{"height", "/", "8"}], "]"}], "-", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"row", "=", "0"}], ",", 
        RowBox[{"row", "<", 
         RowBox[{"Floor", "[", 
          RowBox[{"height", "/", "8"}], "]"}]}], ",", 
        RowBox[{"row", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"column", "=", "0"}], ",", 
          RowBox[{"column", "<", "width"}], ",", 
          RowBox[{"column", "+=", "64"}], ",", "\[IndentingNewLine]", 
          RowBox[{"oled", "@", 
           RowBox[{"Write", "[", 
            RowBox[{
             RowBox[{"pages", "[", 
              RowBox[{"[", 
               RowBox[{"row", "+", "1"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"column", "+", "1"}], ";;", 
               RowBox[{"column", "+", "64"}]}], "]"}], "]"}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], "\n", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Create", " ", "IPConnection", " ", "and", " ", "device", " ", "object"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"ipcon", "=", 
  RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}], "\n", 
 RowBox[{"oled", "=", 
  RowBox[{"NETNew", "[", 
   RowBox[{
   "\"\<Tinkerforge.BrickletOLED128x64\>\"", ",", "uid", ",", "ipcon"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"ipcon", "@", 
   RowBox[{"Connect", "[", 
    RowBox[{"host", ",", "port"}], "]"}]}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Clear", " ", "display"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"oled", "@", 
   RowBox[{"ClearDisplay", "[", "]"}]}], "\n", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Draw", " ", "checkerboard", " ", "pattern"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"pixels", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Floor", "[", 
         RowBox[{"h", "/", "8"}], "]"}], ",", "2"}], "]"}], "\[Equal]", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Floor", "[", 
         RowBox[{"w", "/", "8"}], "]"}], ",", "2"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"h", ",", "0", ",", 
       RowBox[{"height", "-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"w", ",", "0", ",", 
       RowBox[{"width", "-", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DrawMatrix", "[", 
   RowBox[{"oled", ",", "pixels"}], "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Clean", " ", "up"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"ipcon", "@", 
  RowBox[{"Disconnect", "[", "]"}]}], "\n", 
 RowBox[{"ReleaseNETObject", "[", "oled", "]"}], "\n", 
 RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]}], "Input",
 CellChangeTimes->{{3.600075175574196*^9, 3.600075177574486*^9}, {
   3.600075518821967*^9, 3.60007554243471*^9}, {3.600075580562348*^9, 
   3.600075669308506*^9}, {3.600075705822371*^9, 3.600075921974015*^9}, {
   3.6000760067507343`*^9, 3.600076009622583*^9}, {3.600077792659996*^9, 
   3.600077795613958*^9}, {3.600077854705127*^9, 3.600077855342334*^9}, {
   3.600090981053762*^9, 3.6000909897413397`*^9}, {3.600091048393783*^9, 
   3.600091071325759*^9}, {3.6000911068928633`*^9, 3.6000911072763557`*^9}, {
   3.600091413237206*^9, 3.600091428847453*^9}, {3.600091480127982*^9, 
   3.60009150669311*^9}, {3.6000915673213387`*^9, 3.6000915678002653`*^9}, {
   3.600092307925643*^9, 3.600092314241997*^9}, {3.600149020784099*^9, 
   3.6001491107582273`*^9}, {3.600149174456699*^9, 3.6001491869018793`*^9}, {
   3.600161252329417*^9, 3.600161270517737*^9}, {3.6001751050299597`*^9, 
   3.6001752269913054`*^9}, {3.600175283111157*^9, 3.60017529631222*^9}, {
   3.600500425825809*^9, 3.6005004326356916`*^9}, {3.6005005658827868`*^9, 
   3.60050056667803*^9}, {3.600506021813815*^9, 3.6005060779666643`*^9}, {
   3.600506152278829*^9, 3.6005061727773933`*^9}, {3.600607963780426*^9, 
   3.6006080340220013`*^9}, {3.600608128817329*^9, 3.600608130481505*^9}, {
   3.60060817038931*^9, 3.600608171010838*^9}, {3.60060891170606*^9, 
   3.600608950204666*^9}, {3.6007556261232843`*^9, 3.600755697415724*^9}, 
   3.6437096950783052`*^9, 3.651481703020026*^9, {3.660985403153728*^9, 
   3.660985406162938*^9}, {3.660985463529223*^9, 3.660985491111402*^9}, {
   3.660985635116269*^9, 3.660985843039712*^9}, {3.660985888881442*^9, 
   3.660985889484535*^9}, {3.66098599937658*^9, 3.66098601585651*^9}, 
   3.660986049309029*^9, {3.660986145768443*^9, 3.6609861969649982`*^9}, {
   3.6609862281149273`*^9, 3.660986229272881*^9}, {3.660986268056323*^9, 
   3.660986298931395*^9}, {3.660986360544127*^9, 3.6609863992148113`*^9}, {
   3.660986491762435*^9, 3.660986493407695*^9}, {3.66098653070345*^9, 
   3.660986641218848*^9}, {3.6609867121212263`*^9, 3.660986922095168*^9}, {
   3.66098698022585*^9, 3.660987043991346*^9}, {3.660987166684577*^9, 
   3.660987185909237*^9}, {3.6609872741680307`*^9, 3.660987316143693*^9}, {
   3.66098739009562*^9, 3.6609874093595533`*^9}, {3.6609874775563383`*^9, 
   3.6609875019171867`*^9}, {3.6609876031625223`*^9, 
   3.6609876243611307`*^9}, {3.660987667071567*^9, 3.660987693189698*^9}, {
   3.660987734161983*^9, 3.6609878114459057`*^9}, {3.660987870074847*^9, 
   3.660987872582408*^9}, {3.6609879069714727`*^9, 3.660987950982931*^9}, {
   3.6609880209653053`*^9, 3.660988082283546*^9}, 3.660988226249538*^9, {
   3.660988556736335*^9, 3.660988558575717*^9}, {3.66098862216916*^9, 
   3.6609886224235983`*^9}, {3.660988712307714*^9, 3.66098872274098*^9}, {
   3.660988763568602*^9, 3.660988819295589*^9}, {3.6609888838831*^9, 
   3.660988891189095*^9}, 3.660988925862369*^9, {3.660989002709135*^9, 
   3.660989189308825*^9}, {3.6609892898971786`*^9, 3.660989293482024*^9}, {
   3.660989390900003*^9, 3.6609894611008377`*^9}, {3.660989628512299*^9, 
   3.6609896805071793`*^9}, {3.660989725627241*^9, 3.660989729493271*^9}, {
   3.660989845711759*^9, 3.660989854467465*^9}, {3.6609902485114183`*^9, 
   3.6609902735968447`*^9}, {3.660990336187958*^9, 3.660990337676505*^9}, {
   3.6609903683607283`*^9, 3.660990499398644*^9}, 3.660990645683962*^9, {
   3.66099067763404*^9, 3.660990678044813*^9}}]
},
WindowSize->{1521, 867},
WindowMargins->{{Automatic, 187}, {Automatic, 53}},
FrontEndVersion->"9.0 for Linux x86 (64-bit) (November 20, 2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[400, 13, 602, 11, 55, "Input"],
Cell[1005, 26, 9622, 209, 979, "Input"]
}
]
*)

